
/* ------------------------------------------------------------------------
Project:	The Social
Required: 	jquery, gelesocial.js
Copyright:	2011 - Gruppo editoriale L'Espresso spa
Developers:
			M. Viganò, F. Zanchetta, G. Bottini, L. Convalle,
			E. Sabellico, E. Matteoli, L. "saibal" Forti
------------------------------------------------------------------------- */

/* ------------------------------------------------------------------------
	Base functions - Provide interaction with social user data
------------------------------------------------------------------------- */

/*
 * TODO
 * Aggiungere un metodo sull'init che salva dentro una variabile i valori del cookie
 * */

window.getCachedScript = function(script, success){
	var options = {
	 url: script,
	 dataType: "script",
	 cache: true,
	 type: "GET",
	 success: success
	}
	jQuery.ajax(options);  
}

window.locationHrefWithoutHash = function(){
	return document.location.href.split("#")[0]	
}

GeleSocial = {}

/* SETTINGS PARAMETER MAP */
GeleSocial.settings = {
		debug : false,
		test: false,
		pageId : "",
		fIgnoreFBLogged: null,
		statusChangeCallbacks: [],
		fb_plugin_class: "fb-plugin",
		kw_cookie: "",
		kw_neg_cookie: "",
		socialDataUrl : null,
		facebookTimeout: 5000,
		facebookLoginStatusTimeout: 5000,
		openWindowProfiles: {"facebook-share": {width:640,height:400,center:1,createnew:0,scrollbars:0}}
};

GeleSocial.status = {
	fb: {
		logged: false,		// si è loggati su facebook
		sameUser: false,	// l'utente è loggato su facebook con lo stesso utente dell'SSO
		authorized: false,	// l'applicazione è autorizzata
		preventAutologin: false,	// blocca l'esecuzione dell'autologin
		autologin: false,	// sarà (o è stato) fatto l'autologin
		autologinDone: false,   // è stato fatto l'autologin (con successo o meno)
		loaded: false,		// è stato caricato lo stato dell'utente su facebook
		blocked: undefined	// facebook è bloccato (inizialmente non si sa)
	},
	logged: false, 			// si è loggati sul nostro SSO
	transitional: true, 		// lo stato è temporaneo (può diventare definitivo o subito dopo loaded = true o dopo l'autologin)
	loaded: false,			// è stato letto lo stato dell'utente sull'SSO tramite il cookie
	redisError: false		// si è verificato un timeout nella lettura dal redis
};

GeleSocial.lastNotifiedStatus = jQuery.extend(true, {}, GeleSocial.status);

GeleSocial.shadowBoxSettings = {handleOversize: "none"};

GeleSocial.ignoreRulesMatch = function(rules){
	if(rules){
		var loc = window.location.href;
		var match = false;
		jQuery.each(rules, function(i, rule){
			match = loc.match(rule);
			if(match) return false;
		});
		return match;
	} else return false;
}

GeleSocial.settings.fIgnoreFBLogged = function(){
	if(GeleSocial.status.fb.preventAutologin) return true;
	var disableAutoLogin = GeleSocial.settings.disableAutoLogin;

	function compile(rules){
		var baseUrl = GeleSocial.ws.settings.BASE_URL;
		if(!baseUrl || !rules) return null;
		else {
			if(baseUrl[baseUrl.length-1]!="/"){
				baseUrl = baseUrl + "/";
			}
			baseUrl = GeleSocial.utils.regExpQuote(baseUrl);
		}

		var rules1 = [];
		var hasAll = jQuery.grep(rules, function(a, i){
			return a == "__all__";
		}).length > 0;
		if(hasAll){
			rules1.push("^.*$");
		} else {
			jQuery.each(rules, function(i,a){
				if(a=="__home__"){
					rules1.push("^" + baseUrl + "[^/]*$");
				} else {
					a = GeleSocial.utils.regExpQuote(a);
					rules1.push("^" + baseUrl + a + "([/?#].*)?$");
				}
			});
		}
		rules = rules1;
		return rules;
	}

	if(!disableAutoLogin && GeleSocial.settings.disableAutoLoginRegexp){
		return GeleSocial.ignoreRulesMatch(GeleSocial.settings.disableAutoLoginRegexp);
	} else if(disableAutoLogin){
		disableAutoLogin = compile(disableAutoLogin);
		return GeleSocial.ignoreRulesMatch(disableAutoLogin);
	} else return false;
}

/* FACEBOOK STATUS */
GeleSocial.fbSettings = {channelUrl: window.location.protocol + "//" + window.location.host + "/social/common/channel_url.php", appId  : null, status : true, cookie : true, xfbml : true, oauth: true };
GeleSocial.fbId = 'facebookid';
GeleSocial.fbRootTag = "<div id=\"fb-root\"></div>";
GeleSocial.sdkUrl = document.location.protocol +'//connect.facebook.net/it_IT/all.js';

GeleSocial.addInitCallback = function(callback){
	GeleSocial.addStatusChangeCallback(function(last, current){
		if(last.fb.blocked === undefined && current.fb.blocked !== undefined){
			callback();
		}
	});
}

GeleSocial.addFinalStatusCallback = function(callback){
	GeleSocial.addStatusChangeCallback(function(last, current){
		if(last.transitional && !current.transitional){
			callback();
		}
	});
}


GeleSocial.addStatusChangeCallback = function(callback){
	if(GeleSocial.settings && GeleSocial.settings.statusChangeCallbacks){
		GeleSocial.settings.statusChangeCallbacks.push(callback);
	}
}

GeleSocial.notifyStatusChange = function(){
	if(GeleSocial.settings && GeleSocial.settings.statusChangeCallbacks){
		for(var i in GeleSocial.settings.statusChangeCallbacks){
			GeleSocial.settings.statusChangeCallbacks[i](GeleSocial.lastNotifiedStatus, GeleSocial.status);
		}
		GeleSocial.lastNotifiedStatus = jQuery.extend(true, {}, GeleSocial.status);
	}
}

/* INIZIO METODI RIGUARDANTI LA MODALE */
GeleSocial.openModal = function(iframeSrc, content, width, height) {
	if(!window.Shadowbox){GeleSocial.log("Shadowbox non è incluso in pagina");}
	else {
		var settings = $.extend({}, this.shadowBoxSettings);
		var player = 'html';
		if(iframeSrc!==undefined && iframeSrc!==null){
			player = 'iframe';
			content = iframeSrc;
		}
		settings.content = content;
		settings.player = player;
		if(width) settings.width = width;
		if(height) settings.height = height;

		//if(window.Shadowbox.isOpen()) window.Shadowbox.close();
		if(player=="iframe" && window.Shadowbox.isOpen()){
			setTimeout(function(){
				var frame = $("#sb-player");
				frame[0].src = settings.content;
				GeleSocial.resizeModal(settings.width, settings.height);
			}, 1000);
		} else {
			window.Shadowbox.open(settings);
		}
	}
}


GeleSocial.trackingParam = function(element, paramName){
	element.find("a").each(function(i, a){
		a = $(a);
		var href = a.attr("href");
		if(href && href.indexOf('http') == 0 && href.indexOf(paramName) < 0){
			if(href.indexOf('?') > 0){
				href += "&";
			} else href += "?";
			href += "ref=" + paramName + "-" + (i+1);
			a.attr("href", href); 
		}
	});
}


GeleSocial.closeModal = function(){
	if(window.Shadowbox) window.Shadowbox.close();
}

GeleSocial.changedContentModal = function(content){
    if(window.Shadowbox)
        $('#'+window.Shadowbox.skin.body.id).html(content);
}

GeleSocial.resizeModal = function(width, height){
	if(window.Shadowbox) window.Shadowbox.skin.dynamicResize(width, height);
}

GeleSocial.showFormRegistration = function(backurl,optbackurl,here){
    if(this.settings.baseUrlSocial && this.settings.registrationPage){

        if(!backurl) backurl = window.locationHrefWithoutHash();
        backurl = escape(this.settings.baseUrlSocial + "loader.php?mClose=2&backUrl=" + escape(backurl));

        if(!optbackurl) optbackurl = window.locationHrefWithoutHash();
        optbackurl = escape(this.settings.baseUrlSocial + "loader.php?mClose=2&backUrl=" + escape(optbackurl));

        var url4redirect = this.settings.registrationPage + "?backurl=" + backurl+ "&optbackurl=" + optbackurl;
        if(GeleSocial.status.redisError){
            GeleSocial.openModal(this.settings.baseUrlSocial + "loader.php?mClose=5");
        } else {
        	GeleSocial.deleteFBCookies();
            if(here)
                window.location.href = url4redirect;
            else
            	GeleSocial.openModal(url4redirect, null, 920, 700);
        }
    }
}

GeleSocial.showBenefits = function(backurl, parameters, here){
    if(this.settings.baseUrlSocial && this.settings.benefitsPage){
 	    if(parameters) parameters = jQuery.param(parameters) + "&";
	    else parameters = "";

	    if(!backurl) backurl = window.locationHrefWithoutHash();
	    backurl = escape(this.settings.baseUrlSocial + "loader.php?mClose=2&backUrl=" + escape(backurl));
	    var url4redirect = this.settings.benefitsPage + "?" + parameters + "backurl=" + backurl + "&fbBlocked=" + GeleSocial.status.fb.blocked;
	    if(GeleSocial.status.redisError){
		GeleSocial.openModal(this.settings.baseUrlSocial + "loader.php?mClose=5");
	    } else {
        	GeleSocial.deleteFBCookies();
            if(here)
                window.location.href = url4redirect;
            else
            	GeleSocial.openModal(url4redirect, null, 920, 700);
	    }
    }
}

GeleSocial.openWindow = function(url, profile){
	if(GeleSocial.settings.openWindowProfiles && GeleSocial.settings.openWindowProfiles[profile]){
		var settings = GeleSocial.settings.openWindowProfiles[profile];
		if(settings.center==1)
		{settings.top=(screen.height-(settings.height+110))/2;settings.left=(screen.width-settings.width)/2;}
		parameters="location="+settings.location+",menubar="+settings.menubar+",height="+settings.height+",width="+settings.width+",toolbar="+settings.toolbar+",scrollbars="+settings.scrollbars+",status="+settings.status+",resizable="+settings.resizable+",left="+settings.left+",screenX="+settings.left+",top="+settings.top+",screenY="+settings.top;		
		var name="popup-window-" + profile;
		if(GeleSocial.__openedWindows && GeleSocial.__openedWindows[name] && !GeleSocial.__openedWindows[name].closed){
			GeleSocial.__openedWindows[name].focus();
			ret = GeleSocial.__openedWindows[name];
		} else {
			var open = function(){var ret = window.open(url,name,parameters);ret.focus();return ret;};
			var ret = open();
			if(!GeleSocial.__openedWindows) GeleSocial.__openedWindows = {};
			GeleSocial.__openedWindows[name] = ret;
		}
		return ret;
	}
}

GeleSocial.openLoginModal = function(fbBlocked, backurl, parameters, here, facebookOnly){
    if(this.settings.baseUrlSocial && this.settings.loginPage){
        if(parameters)
            parameters = jQuery.param(parameters) + "&";
        else
            parameters = "";

        if(fbBlocked===undefined) fbBlocked = GeleSocial.status.fb.blocked;
        if(!backurl) backurl = window.locationHrefWithoutHash();
        backurl = escape(this.settings.baseUrlSocial + "loader.php?mClose=2&backUrl=" + escape(backurl));
        if(facebookOnly && this.settings.loginOnlyFacebookPage){
        	var url4redirect = this.settings.loginOnlyFacebookPage;
        } else {
        	var url4redirect = this.settings.loginPage;
        }
        url4redirect += "?" + parameters + "backurl=" + backurl + "&optbackurl=" + backurl + "&fbBlocked="+fbBlocked;
        if(GeleSocial.status.redisError){
            GeleSocial.openModal(this.settings.baseUrlSocial + "loader.php?mClose=5");
        } else {
        	GeleSocial.deleteFBCookies();
            if(here)
                window.location.href = url4redirect;
            else {
                if(facebookOnly)
                	GeleSocial.openModal(url4redirect, null, 500, 300);
                else
                	GeleSocial.openModal(url4redirect);
            }
        }
    }
}

GeleSocial.openLoginHere = function(fbBlocked, backurl, parameters){
	GeleSocial.openLoginModal(fbBlocked, backurl, parameters, true);
}

GeleSocial.openSendingComment = function(){
	GeleSocial.openModal(this.settings.baseUrlSocial + "loader.php?mClose=5&type=sending_comment", null, 700, 300);
}

GeleSocial.openCommentSent = function(){
	GeleSocial.openModal(this.settings.baseUrlSocial + "loader.php?mClose=5&type=comment_sent", null, 700, 300);
}

GeleSocial.goToMemberCenter = function(){
	var backurl = GeleSocial.settings.ssoDomain + '/membercenter/membercenter2Servlet?op=sfuupduserprofile&backurl=' + escape(document.location.href);
	backurl =  this.settings.baseUrlSocial + "login4backoffice.php?backUrl=" + escape(backurl);
	document.location.href = backurl;
}

/* FINE METODI RIGUARDANTI LA MODALE */

GeleSocial.log = function(obj) {
	if(this.settings.debug && typeof window.console!='undefined') {
		console.log(obj);
	}
}

GeleSocial.alert = function(message){
    if(window.dhtmlx){
        window.dhtmlx.message(message);
    } else {
        alert(message);
    }
}

GeleSocial.confirm = function(message, callback){
    
    if(window.dhtmlx){

  		dhtmlx.confirm({
		    type:"confirm",
		    text: message,
            cancel: "Annulla",
		    callback: callback
		});

    } else {
        callback(confirm(message));
    }
}

GeleSocial.init = function(settings, wsSettings, fbSettings, shadowBoxSettings) {
	if(!GeleSocial.utils.isNull(shadowBoxSettings)) {
		this.shadowBoxSettings = $.extend(this.shadowBoxSettings, shadowBoxSettings);
	}
	if(!GeleSocial.utils.isNull(settings)) {
		this.settings = $.extend(this.settings, settings);
	}
	if(!GeleSocial.utils.isNull(fbSettings)) {
		this.fbSettings = $.extend(this.fbSettings, fbSettings);
	}
	if(!GeleSocial.utils.isNull(wsSettings)) {
		GeleSocial.ws.init(wsSettings)
	}
}

/* INIZIO FACEBOOK Functions */
GeleSocial.checkFBBlocked = function() {
	var me = this;
	try{
		var prev = null;
		if(window.fbAsyncInit) prev = window.fbAsyncInit;
				
		window.fbAsyncInit = function() {
			if(me.status.fb.blocked!==undefined) return;
			me.status.fb.blocked = false;
			if(prev) prev();

			try {
				GeleSocial.log("Facebook initialized");

				FB.init(me.fbSettings);

				GeleSocial.notifyStatusChange();
				GeleSocial.getLoginStatus();

			} catch(e){}
		};

		var onError = function(){
			if(me.status.fb.blocked!==undefined) return;
			me.status.fb.blocked = true;
			GeleSocial.log("Facebook blocked");
			GeleSocial.ugcInit();
		}

		if(!window.FB){
			if(jQuery("script[src='" + GeleSocial.sdkUrl + "']").length == 0){
				$("body").append(GeleSocial.fbRootTag);
				$.ajax({
					url: GeleSocial.sdkUrl,
					dataType: 'script',
					cache: true
				});
			}

			setTimeout(onError, me.settings.facebookTimeout);
		} else {
			window.fbAsyncInit();
		}

	}catch(e){
		GeleSocial.log("ATTENZIONE! L'SDK DI FACEBOOK NON È STATO CARICATO CORRETTAMENTE!!");
	}
}

GeleSocial.withSocialData = function(callback){
	if(!GeleSocial.utils.isNull(GeleSocial.settings.socialDataUrl)){
		$.ajax({
			url: GeleSocial.settings.socialDataUrl,
			dataType: 'json',
			success: function (data) {
				if(data){
					for(k in data){
						window[k] = data[k];
					}
					callback();
				}
			}
		});
	} else {
		callback();
	}
}

GeleSocial.withJSON2 = function(callback){
    if(window.JSON) callback();
	else {
        window.getCachedScript('/social/common/js/json2.min.js', callback);
	}
}

// Usare solo in caso di problemi con facebook.
// di solito FB cancella i cookie automaticamente
// quando è necessario
//
GeleSocial.deleteFBCookies = function(){
	if(GeleSocial.fbSettings && GeleSocial.fbSettings.appId){
		GeleSocial.deleteCookie("fbsr_" + GeleSocial.fbSettings.appId, null, null, "/");
		GeleSocial.deleteCookie("fbsr_" + GeleSocial.fbSettings.appId, null, RenderSocial.COOKIE_DOMAIN, "/");
	}
}

GeleSocial.fbGetName = function(socialData){
    var uName = "";
    if(GeleSocial.utils.isEmptyString(socialData['firstname']))
      uName = socialData['nickname'];
    else
      uName = socialData['firstname'];
    return uName;
}

GeleSocial.temporaryStatusAvailable = function(){
		var me = this;

		var autologin = me.status.fb.autologin;
		if(autologin){
			GeleSocial.startAutologin();
		} else {
			if(!me.status.logged) me.status.transitional = false;
		}

		if(me.status.logged && !me.status.fb.autologin){
			GeleSocial.readSocialData();
		}

		GeleSocial.notifyStatusChange();
}

GeleSocial.getLoginStatus = function(){
	var me = this;

	var callback = function(response) {
		if(me.status.fb.loaded) return;
		me.status.fb.loaded = true;

		try {

			if(response){

				if (response.status == "connected") {
					me.status.fb.logged = true;
					me.status.fb.authorized = true;
					if(response.authResponse && response.authResponse.userID){
						me.status.fb.id = response.authResponse.userID;
					}
				} else if(response.status != "notConnected"){
					GeleSocial.deleteFBCookies();
				}

			}

			GeleSocial.checkStatus();

			if(!me.status.logged &&
				me.status.fb.logged &&
				me.status.fb.authorized &&
					(!GeleSocial.settings.fIgnoreFBLogged
					|| !GeleSocial.settings.fIgnoreFBLogged())){
				me.status.fb.autologin = true;
			}

			GeleSocial.temporaryStatusAvailable();

		} catch(e){
			GeleSocial.log("errore: " +  e);
		}
	}

	if(me.settings.ignoreLoginStatus){
		callback("loaded")
	} else {
		FB.getLoginStatus(callback, true);
	}

	// fix per risolvere il problema della mancata chiamata della callback
	// da parte di facebook
	setTimeout(function(){FB.Event.fire('FB.loginStatus', 'loaded');}, me.settings.facebookLoginStatusTimeout);
}
/* FINE FACEBOOK Functions */

GeleSocial.ugcInit = function (){
	var me = this;
	GeleSocial.checkStatus();
	GeleSocial.temporaryStatusAvailable();
}

/** restituisce true se attualmente l'utente non è loggato,
* ma sarà fatto l'autologin.
*/
GeleSocial.willAutologin = function(){
	var me = this;
	return (me.status && me.status.fb.autologin);
}

GeleSocial.addCookieListener = function(listener){
	if(!this._cookieListeners) this._cookieListeners = [];
	this._cookieListeners.push(listener);
}

GeleSocial.normalLogin = function(onresponse, perms){
	if(FB) FB.login(onresponse, {perms: perms});
}

GeleSocial.autoLoginError = function(){
	var me = this;
	if(me.status.fb.autologinDone) return;
	me.status.fb.autologinDone = true;
	me.status.transitional = false;

	GeleSocial.notifyStatusChange();
}

GeleSocial.startAutologin = function(){
      var baseUrl = this.settings.baseUrlSocial + "loader.php";
      var bckUrl = baseUrl+"?mClose=4";
      var url4redirect = baseUrl+"?mClose=6&autologin=true&backUrl=" + bckUrl;
      $("body").append("<iframe src=\"" + url4redirect + "\" name=\"iframe\" width=\"0\" height=\"0\" scrolling=\"No\" frameborder=\"0\" id=\"iframe\" ></iframe>");
      setTimeout(function(){GeleSocial.autoLoginError();}, this.settings.facebookTimeout);
}

GeleSocial.autoLogin = function(){
    var me = this;
    if(me.status.fb.autologinDone) return;
    me.status.fb.autologinDone = true;

    GeleSocial.checkStatus();
    if(me.status.logged){

    	GeleSocial.notifyStatusChange();
		GeleSocial.readSocialData();

	} else {
		me.status.transitional = false;
		GeleSocial.notifyStatusChange();
	}
}

GeleSocial.readSocialData = function(){
	var me = this;
	var myCallback = function(){
		me.status.transitional = false;
		GeleSocial.notifyStatusChange();
		$("body").addClass("logged");
	}
	GeleSocial.withSocialData(myCallback);
}

GeleSocial.checkIgnoreLogged = function(){
    var me = this;
    if(me.settings.ignoreLogged || me.status.ignoreLogged){
	   	me.status.logged = false;
	   	me.status.fb.preventAutologin = true;        
    }
}

GeleSocial.checkStatus = function() {

	var me = this;
	//read user information
	var user = me.getUser();
	if(user){
		me.status.logged = true;
		me.status.user = user;
	}

	if(GeleSocial.ws.settings.CHECK_REDIS && !GeleSocial.utils.isNull(me.status.user)){
	   var errorCode = GeleSocial.checkRedisError();
	   if(errorCode){
            if(errorCode == 600){			
                me.status.redisError = true;
            } else if(errorCode == 400){
            	me.status.logged = false;
            	me.status.user = null;
            	GeleSocial.deleteCookie(me.settings.kw_cookie, null, RenderSocial.COOKIE_DOMAIN, "/");
            } else {
            	me.status.ignoreLogged = true;
            }
	   }
	}
    GeleSocial.checkIgnoreLogged();

    /*Test on negative cookie. Prevent all the other controls*/
    var negCookieValue = GeleSocial.getCookie(this.settings.kw_neg_cookie);
    if(!GeleSocial.utils.isNull(negCookieValue)){
    	if(!me.status.logged){
    		me.status.fb.preventAutologin = true;
    	} else {
    		GeleSocial.deleteCookie(this.settings.kw_neg_cookie, null, null, "/");
    	}
    }

	if(me.status.fb.id && me.status.user && me.status.user && me.status.user[GeleSocial.fbId] && me.status.user[GeleSocial.fbId] == me.status.fb.id){
		me.status.fb.sameUser = true;
	}

	me.status.loaded = true;
}

GeleSocial.userPermission = function(f){
//check if a user allow publish_stream for the given application
    if(!GeleSocial.utils.isNull(f)){
       var query = FB.Data.query('select publish_stream from permissions where uid={0}', FB.getSession().uid);
       query.wait(function(rows) {
           if(rows[0].publish_stream == 1) {
              f(true);
           } else {
              f(false);
           }
       });
    }
}

GeleSocial.logOut = function(backUrl) {
	var me = this;
	if(backUrl===undefined){
		backUrl = location.href;
	}
	var parameters  = {};
	parameters['bckurl'] = backUrl;
	var callback = function(){
		GeleSocial.ws.logout(parameters);
	}

	if(me.status.logged && me.status.user && me.status.user[GeleSocial.fbId] && me.status.fb.logged){
		FB.getLoginStatus(function(response){
			if(response && response.authResponse && response.authResponse.userID == me.status.user[GeleSocial.fbId] && response.authResponse.accessToken){
				FB.logout(function(response) {
				  callback();
				});
			} else {
				callback();
			}
		}, true)

	} else {
		callback();
	}

}

GeleSocial.getUser = function() {
    //read the social cookie
	var cookieValue = GeleSocial.getCookie(this.settings.kw_cookie);
    if(!GeleSocial.utils.isNull(cookieValue)){
       var cV = cookieValue.split('|');
       var kwSocial = {};
       kwSocial['memkey']     = cV[0];
       kwSocial['user']       = cV[1];
       kwSocial['firstname']  = cV[2];
       kwSocial['lastname']   = cV[3];
       kwSocial['nickname']   = cV[4];
 	   kwSocial[GeleSocial.fbId] = cV[5];
	   return kwSocial;
    }else{
       return null;
    }
}

GeleSocial.getMemKey = function() {
    //read the social cookie
	var cookieValue = GeleSocial.getCookie(this.settings.kw_cookie);
    if(!GeleSocial.utils.isNull(cookieValue)){
       var cV = cookieValue.split('|');
       var mk = cV[0];
       return mk;
    }else{
       return null;
    }
}

GeleSocial.isLogged = function(){
	var me = this;
	return me.status.logged;
}

GeleSocial.isLoggedFb = function(){
	var me = this;
	return me.status.fb.logged && me.status.fb.sameUser;
}

GeleSocial.checkRedisError = function(){
	var res = GeleSocial.getPageCookies()
	if(res["error_code"]){
		return res["error_code"];
	} else {
		return false;
	}
}


GeleSocial.canReadBoxData = function() {
	return GeleSocial.isLogged();
}

GeleSocial.getCookie = function(pageKey) {
	var cookieValue = $.cookie(pageKey);
    return cookieValue;
}

GeleSocial.setCookie = function(pageKey, value, days, domain, path) {
	try{
		var params = {};

		if (!GeleSocial.utils.isNull(days) && (typeof days==="number"))
			$.extend(params, {expires: days});

		if (!GeleSocial.utils.isNull(domain))
			$.extend(params, {domain: domain});

		if (!GeleSocial.utils.isNull(path))
			$.extend(params, {path: path});

		return $.cookie(pageKey, value, params);
	}catch(e){
		GeleSocial.log("ATTENZIONE! COOKIE NON SALVATO!");
	}
}

GeleSocial.deleteCookie = function(name, expires, domain, path){
	$.cookie(name, null, { expires: expires, domain: domain, path: path});
}

GeleSocial.getPageCookies = function(force) {
	force = (!GeleSocial.utils.isNull(force)) ? force : false;
	if(!force && this._pageCookies) return this._pageCookies;
	else {
		var ret = {};
		if(this.canReadBoxData()) {
			var parameters = {};
			parameters['page'] = this.settings.pageId;
			var response = GeleSocial.ws.redis(parameters);

			if(!GeleSocial.utils.isNull(response) && !GeleSocial.utils.isNull(response['boxes'])) {
				ret = response['boxes'];
			} else ret = response;
			this._pageCookies = ret;
		}
		return ret;
	}
}

GeleSocial.deleteBoxCookie = function(box) {
	var boxKey = GeleSocial.ws.getBoxKey(box);
	if(boxKey!=null) {
		if(this.canReadBoxData()) {
			var parameters = {};
			parameters['page'] = this.settings.pageId;
			parameters['delete'] = 1;
			parameters['box'] = boxKey;
			delete this.getPageCookies()[boxKey];
			return GeleSocial.ws.redisPost(parameters);
		} else {
			return $.cookie(boxKey);
		}

		if(this._cookieListeners){
			jQuery.each(this._cookieListeners, function(i, a){
				if(a && a.onCookieDeleted) a.onCookieDeleted(boxKey);
			});
		}
	}
}

GeleSocial.deletePageCookies = function() {
	if(this.canReadBoxData()) {
		var parameters = {};
		parameters['page'] = this.settings.pageId;
		parameters['delete'] = 1;
		var _this = this;
		var pageCookies = jQuery.extend({}, GeleSocial.getPageCookies());
		delete this._pageCookies;
		var ret = GeleSocial.ws.redisPost(parameters);
		jQuery.each(pageCookies, function(k, v){
			if(_this._cookieListeners){
				jQuery.each(_this._cookieListeners, function(i, a){
					if(a && a.onCookieDeleted) a.onCookieDeleted(k);
				});
			}
		});
		return ret;
	} else {
		return $.cookie(boxKey);
	}
}

GeleSocial.getBoxCookie = function(box, force) {
	force = (!GeleSocial.utils.isNull(force)) ? force : false;
	var boxKey = GeleSocial.ws.getBoxKey(box);
	var ret =  this.getPageCookies(force)[boxKey];
	if(ret === undefined) ret = {};
	return ret;
}

GeleSocial.setBoxCookie = function(box, values) {
	var boxKey = GeleSocial.ws.getBoxKey(box);
	if(boxKey!=null) {
		GeleSocial.log(this.canReadBoxData());
		if(this.canReadBoxData()==true) {
			GeleSocial.log("setBoxCookie - canReadBoxData=true");
			if(!GeleSocial.utils.isNull(values)) {
				var parameters = {};
				parameters['page'] = this.settings.pageId;
				parameters['box'] = boxKey;
				this.getPageCookies()[boxKey] = values;
				GeleSocial.ws.redisPost(parameters, values);
			} else {
				this.deleteBoxCookie(boxKey);
			}
		} else {
			GeleSocial.log("setBoxCookie - canReadBoxData=false");
			GeleSocial.log("setBoxCookie - boxKey="+boxKey);
			var cookieValue = $.cookie(boxKey);
			GeleSocial.log("setBoxCookie - cookieValue="+cookieValue);
			GeleSocial.log("setBoxCookie - values=");
			GeleSocial.log(values);
			if(!GeleSocial.utils.isNull(cookieValue)) {
				GeleSocial.log("setBoxCookie - leggo da redis");
				var cookieValueMap = GeleSocial.ws.getParameterPost(cookieValue);
				cookieValueMap = $.extend(cookieValueMap, values);
				var cookieValuesString =  GeleSocial.ws.buildParametersPost(cookieValueMap);
				$.cookie(boxKey, cookieValuesString);
				this.getPageCookies()[boxKey] = values;
			} else {
				GeleSocial.log("setBoxCookie - non leggo da redis");
				var cookieValuesString =  GeleSocial.ws.buildParametersPost(values);
				$.cookie(boxKey, cookieValuesString);
				this.getPageCookies()[boxKey] = values;
			}
		}
		if(this._cookieListeners){
			jQuery.each(this._cookieListeners, function(i, a){
				if(a && a.onCookieSet) a.onCookieSet(boxKey, values);
			});
		}
	}
}

/* ------------------------------------------------------------------------
	Render functions - Provide html render of social boxes in the pages
------------------------------------------------------------------------- */
GeleSocial.render = function(parameters, f) {
    if(!GeleSocial.utils.isNull(f) && !GeleSocial.utils.isNull(parameters) && $.isFunction(f))
        f(parameters);
}

/* FACEBOOK SOCIAL PLUGIN FBML */
GeleSocial.render.FB_ACTIVITYFEED_PLUGIN = "fb:activity";
GeleSocial.render.FB_LIKE_PLUGIN = "fb:like";
GeleSocial.render.FB_SEND_PLUGIN = "fb:send";
GeleSocial.render.FB_LIKE_BOX_PLUGIN = "fb:like-box";
GeleSocial.render.FB_LOGIN_PLUGIN = "fb:login-button";
GeleSocial.render.FB_RECOMMENDATION_PLUGIN= "fb:recommendations";
GeleSocial.render.FB_FACEPILE_PLUGIN= "fb:facepile";
GeleSocial.render.FB_COMMENTS_PLUGIN= "fb:comments";

GeleSocial.render.pluginString = function(type, parameters, content) {
	var parametersString = this._buildSocialPluginParameters(parameters);
	if(GeleSocial.utils.isNull(content)) content='';
	return '<'+type+' '+parametersString+'>'+content+'</'+type+'>';
}

GeleSocial.render.plugin = function(type, id, parameters, content, logged) {
	if(!GeleSocial.utils.isNull(id) && $(id).length != 0) {
		$(id).hide();
		var pluginString =  this.pluginString(type, parameters, content);
		$(id).html(pluginString);
		if(!GeleSocial.utils.isNull(logged) && !logged) {
			$(id).addClass(GeleSocial.settings.fb_plugin_class);
			$(id).show();
		} else {
			$(id).addClass(GeleSocial.settings.fb_plugin_class+"-logged");
		}
	}
}

GeleSocial.render.activityFeedString = function(parameters, content) {
	return this.pluginString(this.FB_ACTIVITYFEED_PLUGIN, parameters,content);
}

GeleSocial.render.loginString = function( parameters, content) {
	return this.pluginString(this.FB_LOGIN_PLUGIN, parameters, content);
}

GeleSocial.render.sendButtonString = function(parameters) {
	return this.pluginString(this.FB_SEND_PLUGIN, parameters,'');
}

GeleSocial.render.likeButtonString = function(parameters) {
	return this.pluginString(this.FB_LIKE_PLUGIN, parameters,'');
}

GeleSocial.render.likeBoxString = function(parameters) {
	return this.pluginString(this.FB_LIKE_BOX_PLUGIN, parameters,'');
}

GeleSocial.render.recommendationsString = function(parameters) {
	return this.pluginString(this.FB_RECOMMENDATION_PLUGIN, parameters,'');
}

GeleSocial.render.facePileString = function(parameters) {
	return this.pluginString(this.FB_FACEPILE_PLUGIN, parameters,'');
}

GeleSocial.render.activityFeed = function(id, parameters, logged) {
	GeleSocial.render.plugin(this.FB_ACTIVITYFEED_PLUGIN, id, parameters, '', logged);
}

GeleSocial.render.recommendations = function(id, parameters, logged) {
	return this.plugin(this.FB_RECOMMENDATION_PLUGIN, id, parameters,'', logged);
}

GeleSocial.render.likeButton = function(id, parameters, logged) {
	GeleSocial.render.plugin(this.FB_LIKE_PLUGIN, id, parameters, '', logged);
}

GeleSocial.render.loginButton = function(id, parameters, content, logged) {
	GeleSocial.render.plugin(this.FB_LOGIN_PLUGIN, id, parameters, content, logged);
}

GeleSocial.render.facePile = function(id, parameters, logged) {
	GeleSocial.render.plugin(this.FB_FACEPILE_PLUGIN, id, parameters, '', logged);
}

GeleSocial.render.comments = function(id, parameters, logged) {
	GeleSocial.render.plugin(this.FB_COMMENTS_PLUGIN, id, parameters, '', logged);
}

GeleSocial.render._buildSocialPluginParameters = function(parameters) {
	parametersString = "";
	if (!GeleSocial.utils.isNull(parameters)) {
		$.each(parameters, function(key, value) {
			parametersString += key+'="'+value+'" ';
		});
	}
	return parametersString;
}

/* ------------------------------------------------------------------------
	WS functions - Provide dialog with social ws
------------------------------------------------------------------------- */
GeleSocial.ws = {}

GeleSocial.ws.settings = {
		BASE_URL : "",
		REDIS : "redis.php",
		UGC_FORM : "ugccommentform.php",
		LOGOUT: "logout.php",
		KEY_VAL_SEPARATOR: "|||",
		PARAMETERS_SEPARATOR: "@@@"
};


GeleSocial.ws.TYPE_JSON = "json"

GeleSocial.ws.init = function(settings) {
	if(!GeleSocial.utils.isNull(settings)) {
		this.settings = $.extend(this.settings, settings);
	}
}

GeleSocial.ws.buildParametersPost = function(values) {
	var me = this;
	var string = "";
	var oLength = GeleSocial.utils.getObjectLength(values);
	if(typeof values!='undefined' && values!=null)  {
		var index = 0;
		$.each(values, function(key, value) {
			if(value==null) value="null";
			string+=key+me.settings.KEY_VAL_SEPARATOR+value;
			if(index<(oLength-1)) string+=me.settings.PARAMETERS_SEPARATOR;
			index++;
		});
	}
	return string;
}

GeleSocial.ws.getParameterPost = function(string) {
	var me = this;
	var map = {};
	if(!GeleSocial.utils.isEmptyString(string)) {
		GeleSocial.log(string);
		GeleSocial.log(me.settings.PARAMETERS_SEPARATOR);
		var parameters = string.split(me.settings.PARAMETERS_SEPARATOR);
		$.each(parameters, function(index) {
			var keyVal = parameters[index].split(me.settings.KEY_VAL_SEPARATOR);
			if(!GeleSocial.utils.isNull(keyVal) && keyVal.length==2) {
				var key = keyVal[0];
				var value = keyVal[1];
				map[key] = value;
			}
		});
	}
	return map;
}

GeleSocial.ws.getBoxKey = function(boxName) {
	if(!GeleSocial.utils.isEmptyString(boxName)) {
		var key = boxName.toLowerCase();
		key = key.replace(" ", "_");
		key = key.replace("__", "_");
		return key;
	}
	return null;
}

GeleSocial.ws.jsonpCall = function(service, f, params) {
	if(!GeleSocial.utils.isNull(f) && !GeleSocial.utils.isNull(params) && !GeleSocial.utils.isNull(params)) {
		var parameters = {};
		if(!GeleSocial.utils.isNull(params)) {  parameters = $.extend(parameters, params); }

		$.getJSON(this.settings.BASE_URL + service + "?jsoncallback=?",
		  parameters,
		  function(data) { f(data); }
		);
	}
}

GeleSocial.ws.ugcForm = function(htmlId, idArticolo, brand, callback, callbackNotLogged){
	GeleSocial.log("GeleSocial.ws.ugcForm");
	if(!GeleSocial.utils.isEmptyString(idArticolo) && !GeleSocial.utils.isEmptyString(htmlId)) {
		var url = this.settings.BASE_URL + this.settings.UGC_FORM+"?idarticolo="+idArticolo+"&brand="+brand;
		GeleSocial.log(htmlId);
		if(GeleSocial.canReadBoxData()) {
			if($("#loading-form").length>0)
				$("#loading-form").show();
			$(htmlId).load(url, function(response, status, xhr) {
			  if (status == "error") {
				  GeleSocial.log("ugcForm - Impossibile prelevare la form di commento ugc dalla url "+ url);
			  } else if(status=="success") {
					if(!GeleSocial.utils.isNull(callback) && $.isFunction(callback))
						callback();
			  }
			  if($("#loading-form").length>0)
					$("#loading-form").hide();
			  GeleSocial.log(status);
			});

		} else {
			if(!GeleSocial.utils.isNull(callbackNotLogged) && $.isFunction(callbackNotLogged)){
				callbackNotLogged();
			}
		}
	} else {
		GeleSocial.log("ugcForm - Parametri mancanti");
	}
}

GeleSocial.ws.ugcFormPost = function(formId, ugcParams, callBack, callBackError) {
	GeleSocial.log("GeleSocial.ws.ugcFormPost");
	var parameters = {};
	var serializedParams = $(formId).serialize();
	serializedParams+="&"+$.param(ugcParams);

	$.ajax({
	  type: 'POST',
	  url: this.settings.BASE_URL + this.settings.UGC_FORM,
	  data: serializedParams,
	  success: function(data) {
		  if(!GeleSocial.ws.isJsonError(data)) {
			GeleSocial.log("Risultato post commento:");
			GeleSocial.log(data);
		 	callBack();
		  } else {
			  callBackError(data['error_code'], data['error_msg']);
		  }
	  }
	});

}

GeleSocial.ws.logout = function(parameters) {
	if(parameters && parameters['bckurl']) {
		var backUrl = parameters['bckurl'];
		document.location.href = this.settings.BASE_URL + this.settings.LOGOUT + "?bckurl=" + escape(backUrl);
	}
}

GeleSocial.ws.redis = function(parameters) {
	var dataRet = null;
	if(!GeleSocial.utils.isNull(parameters)) {
		$.ajax({
			url: this.settings.BASE_URL + this.settings.REDIS,
  			async: false,
			data: parameters,
			dataType: 'json',
			success: function (data) {
				if(GeleSocial.ws.isJsonError(data)) {
					if(data["error_code"]==200){
						dataRet = {"boxes": {}}
					} else {
						GeleSocial.log(data['error_msg']);
						dataRet = data;
					}
				} else {
					GeleSocial.log(data);
					dataRet = data;
				}
			}
		});
	}
	return dataRet;
}

GeleSocial.ws.redisPost = function(parameters, values) {
	var dataRet = false;
	if(!GeleSocial.utils.isNull(values) && GeleSocial.utils.getObjectLength(values)>0) {
		valuesString = this.buildParametersPost(values);
		parameters['params'] = valuesString;
	}

	if(!GeleSocial.utils.isNull(parameters)) {
		if(!GeleSocial.utils.isNull(GeleSocial.settings.kw_cookie) && !GeleSocial.utils.isNull($.cookie(GeleSocial.settings.kw_cookie)) ){

			// richiesto per la protezione anti CSRF
			parameters[GeleSocial.settings.kw_cookie] = $.cookie(GeleSocial.settings.kw_cookie);

			$.post(this.settings.BASE_URL + this.settings.REDIS,
			  parameters,
			  function(data) {
				 dataRet = GeleSocial.ws.isJsonError(data);
			  }
			);
		}
	}
	return dataRet;
}

GeleSocial.ws.isJsonError = function(json) {
	if(!GeleSocial.utils.isNull(json) && json['error']=="true") {
		return true;
	} else if(GeleSocial.utils.isNull(json)) {
		return true;
	}
	return false;
}

GeleSocial.getOrigin = function() {
	var protocol = "http://";
	var string = protocol;
	var url = location.href;
	var indexProtocol = url.indexOf(protocol);
	if(indexProtocol!=-1) {
		var protocolLength = protocol.length;
		var cleanUrl = url.substring(indexProtocol+protocolLength, url.length);
		var d = cleanUrl.split("/",2);
		i = 0;
		$.each(d, function(index) {
			string +=  d[index];
			if(i<d.length-1) string+="/";
			i++;
		});
	} else {
		string = url;
	}
	return string;
}

/*---------------------- Class Utils
-------------------------------------------*/
GeleSocial.utils = {}

GeleSocial.utils.isNull = function(v) {
	return !(!typeof(v)!='undefined' && v!=null && v!="null");
}

GeleSocial.utils.isObjectNull = function(v) {
    return GeleSocial.utils.getObjectLength(v)==0;
}

GeleSocial.utils.getObjectLength = function(obj) {
	var size=0, key;
	for(key in obj) {
		size++;
	}
	return size;
}

GeleSocial.utils.isEmptyString = function(v) {
    return !(!GeleSocial.utils.isNull(v) && $.trim(v)!="");
}

GeleSocial.utils.regExpQuote = function(str) {
    return str.replace(/([.?*+^$[\]\\(){}-])/g, "\\$1");
}

if(window.Shadowbox) window.Shadowbox.init({skipSetup: true});
$.extend({
	GeleSocial: function(settings, wsSettings, fbSettings, shadowBoxSettings) {
		if(!GeleSocial.settings.disableEverything){
			var ready = function(){
                GeleSocial.withJSON2(function() {
				    GeleSocial.log("GeleSocial.init");
				    GeleSocial.init(settings, wsSettings, fbSettings, shadowBoxSettings);
				    GeleSocial.checkFBBlocked();
                });
			}
			
			if(window.onGigyaServiceReady){
				var existing = window.onGigyaServiceReady;
				window.onGigyaServiceReady = function(serviceName){
					existing(serviceName);
					if(serviceName != "socialize") return;
					if(window.gigya){
						var existing1 = gigya.external.facebook.load;
						gigya.external.facebook.load = function(a){
							existing1(a);
							ready();
						}
					} else ready();
				}
			} else {
				$(document).ready(ready);
			}
		} else {
			if(window.RenderSocial && window.RenderSocial.disable) RenderSocial.disable("everything");
		}
	}
});

function Counter(sec, url, options) {

	this.seconds = sec+1;
	this.url = url;
	this.defOptions =  {
		time: 1000,
		finalTime: 3000,
		finalValue: 0,
		step: -1,
		messageId: "#message",
		timeId: "#seconds",
		messageRedirect: "Redirect in corso..."
	}

	this.options = $.extend(this.defOptions, options);

	this.isLastItem = function() {
		if(this.options.step>0) {
			return this.seconds<=this.options.finalValue;
		} else {
			return this.seconds>=this.options.finalValue;
		}
	}

	this.countdown = function() {
		  	 this.seconds = this.seconds+this.options.step;
		 if (this.isLastItem()){
			$(this.options.timeId).html(this.seconds);
			setTimeout(function(thisObj) {thisObj.countdown();}, this.options.time, this);
		 } else {
			$(this.options.messageId).html(this.options.messageRedirect);
			setTimeout("location.href=\""+this.url+"\"",this.options.finalTime);
		 }
	}
}

/* JQUERY.COOKIE.JS */
jQuery.cookie=function(a,b,c){if(arguments.length>1&&String(b)!=="[object Object]"){c=jQuery.extend({},c);if(b===null||b===undefined){c.expires=-1}if(typeof c.expires==="number"){var d=c.expires,e=c.expires=new Date;e.setDate(e.getDate()+d)}b=String(b);return document.cookie=[encodeURIComponent(a),"=",c.raw?b:encodeURIComponent(b),c.expires?"; expires="+c.expires.toUTCString():"",c.path?"; path="+c.path:"",c.domain?"; domain="+c.domain:"",c.secure?"; secure":""].join("")}c=b||{};var f,g=c.raw?function(a){return a}:decodeURIComponent;return(f=(new RegExp("(?:^|; )"+encodeURIComponent(a)+"=([^;]*)")).exec(document.cookie))?g(f[1]):null}
