/* ------------------------------------------------------------------------
Project:    The Social
Required:   jquery, gelesocial.js
Copyright:  2011 - Gruppo editoriale L'Espresso spa
Developers:
            M. Viganò, F. Zanchetta, G. Bottini, L. Convalle,
            E. Sabellico, E. Matteoli, L. "saibal" Forti
------------------------------------------------------------------------- */


RenderSocial = function (){}

/* SETTINGS PARAMETER MAP */
RenderSocial.boxCookieName = {"repubblica_oroscopo":"Oroscopo","repubblica_borsa":"Borsa", "repubblica_sport_squadra":"Squadra","box-meteo-sidebar":"Meteo", "adagio_box_locali":"Edizioni Locali"};

//SITE SETTINGS
RenderSocial.APP_PERMISSION      			= "publish_stream, email, user_birthday, user_interests, user_likes, user_location, publish_actions";
RenderSocial.FB_APP_ID            			= 182234715127717;
RenderSocial.FB_APP_URL            			= "http://www.facebook.com/Repubblica";
RenderSocial.UGC_BRAND_ID          			= 1;
RenderSocial.UGC_TOOLS_COMMENTS_CLASS		= "tools-comments";
RenderSocial.UGC_FORM_COMMENTS_ID  			= "#commento";
RenderSocial.UGC_CONTAINER_ID      			= "ugc_scContainer";
RenderSocial.UGC_COUNT_ID      				= "ugc_count";
RenderSocial.UGC_CHECKBOX_COMMENT_ID		= "cb_canpostfb";
RenderSocial.REDIS_PAGE_ID        			= "repubblica_social";
RenderSocial.CHECK_LOCATION      			= true;
RenderSocial.COOKIE_DOMAIN       			= ".repubblica.it";
RenderSocial.COOKIE_PATH       				= "/";
RenderSocial.COOKIE_NAME            		= "KWSOCIAL";
RenderSocial.NEG_COOKIE_NAME        		= "NOTKWSOCIAL";
RenderSocial.BASEURL                		= "http://www.repubblica.it/";
RenderSocial.BASEURL_SOCIAL      			= "http://www.repubblica.it/social/sites/repubblica/nazionale/";

//GENERAL SETTINGS
RenderSocial.SOCIAL_DIV          			= ".render-social";
RenderSocial.SOCIAL_BOTTOM        			= "render-social-bottom";
RenderSocial.DIALOG              			= "#dialog";
RenderSocial.BREAKING_NEWS_ID      			= "breaking-news";
RenderSocial.USER_ACCESS_ID    				= "user-access";
RenderSocial.STATUS_BAR_CLASS      			= "status-bar";
RenderSocial.SHOWHIDE_OFF_CLASS    			= "showhide-off";
RenderSocial.TOOLBAR_SOCIAL_ID     			= "toolbar-social";
RenderSocial.TOOLBAR_SOCIAL_BOXES_CLASS 	= "arrow";
RenderSocial.TOOLBAR_SOCIAL_CONTAINER_CLASS = ".from-generic-box";
RenderSocial.TOOLBAR_SHOWHIDE_CLASS    		= "toolbar-showhide";
RenderSocial.RECOMMENDATIONS_DETAIL_ID     	= "reccomandations-detail-box";

//PROFILE PAGE SETTINGS
RenderSocial.FRIENDS_ACTIVITY      			= "http://www.repubblica.it/social/sites/repubblica/nazionale/custom.php";
RenderSocial.UPDT_PROFILE          			= "http://www.repubblica.it/social/sites/repubblica/nazionale/profile.php";
RenderSocial.SOCIAL_DATA            		= "http://www.repubblica.it/social/sites/repubblica/nazionale/social_data.js.php";
RenderSocial.BREAKING_NEWS          		= "http://www.repubblica.it/__zona/ultimora.html";
RenderSocial.PP_FACEPILE_DIV        		= "#facepile";
RenderSocial.PP_ACTIVITY_DIV        		= "#activity";
RenderSocial.PP_LOGIN_2_APPROVE_DIV 		= "#loginbutton";
RenderSocial.LOGOUT_REL             		= "gelesocial-logout";
RenderSocial.LOGIN_PAGE						= "https://login.kataweb.it/registrazione/repubblica.it/login.jsp";
RenderSocial.LOGIN_ONLY_FACEBOOK_PAGE		= "https://login.kataweb.it/registrazione/repubblica.it/loginfacebook.jsp";
RenderSocial.BENEFITS_PAGE          		= "https://login.kataweb.it/registrazione/repubblica.it/benefits.jsp";
RenderSocial.SSO_DOMAIN						= "https://login.kataweb.it";
RenderSocial.SSO_SERVICE_LOGIN				= "repubblica.it.facebook";
RenderSocial.SSO_SERVICE_REGISTRATION		= "repubblica.it.fb";
RenderSocial.CLOSE_MODAL_REGISTRATION		= "http://www.repubblica.it/social/sites/repubblica/nazionale/loader.php?mClose=2";
RenderSocial.REGISTRATION_PAGE				= "https://login.kataweb.it/registrazione/repubblica.it/privato.jsp";
RenderSocial.CUSTOM_CENTER_DIV_ID  			= "content-center";

//$ssoRedirect = SSO_DOMAIN . SSO_REGISTER."?originId=pubblica&backurl=" . $backurl . "&optbackurl=" . $optBackUrl;

// DISABLE SETTINGS
RenderSocial.DISABLE_AUTO_LOGIN = [];
RenderSocial.DISABLE_BOXES = false;

RenderSocial.disableBoxes = function(){
    if(!RenderSocial.DISABLE_BOXES) return false;
    else {
        if(RenderSocial._hasToDisableBoxes===undefined){
            RenderSocial._hasToDisableBoxes = GeleSocial.ignoreRulesMatch(["^.*$"]);
        }
        return RenderSocial._hasToDisableBoxes;
    }
}

RenderSocial.getCommonSettings = function(){
    var settings = {
                        pageId: RenderSocial.REDIS_PAGE_ID,
                        kw_cookie: RenderSocial.COOKIE_NAME,
                        kw_neg_cookie: RenderSocial.NEG_COOKIE_NAME,
                        baseUrlSocial: RenderSocial.BASEURL_SOCIAL,
                        loginPage: RenderSocial.LOGIN_PAGE,
                        loginOnlyFacebookPage: RenderSocial.LOGIN_ONLY_FACEBOOK_PAGE,
                        benefitsPage: RenderSocial.BENEFITS_PAGE,
                        registrationPage: RenderSocial.REGISTRATION_PAGE,
                        ssoDomain: RenderSocial.SSO_DOMAIN,
                        ssoServiceLogin: RenderSocial.SSO_SERVICE_LOGIN,
                        ssoServiceRegistration: RenderSocial.SSO_SERVICE_REGISTRATION
                    };
    if(RenderSocial.DISABLE_AUTO_LOGIN){
        settings.disableAutoLogin = RenderSocial.DISABLE_AUTO_LOGIN;
    }
    return settings;
}


RenderSocial.getCommonWsSettings = function(){
    var wsSettings = {
            BASE_URL: RenderSocial.BASEURL_SOCIAL,
            CHECK_REDIS: true
    };
    return wsSettings;
}

RenderSocial.isInvited = function(page, callback){
	var invited = false;
	//var hasCookie = GeleSocial.getCookie("social_invitation");
	var hasCookie = document.cookie.indexOf("social_invitation")>=0;
	// aperto a tutti
	hasCookie = window.GeleSocial && window.GeleSocial.settings && !window.GeleSocial.settings.disableEverything;
	if(hasCookie){
		invited = true;
		if(callback && jQuery.isFunction(callback)){
			if(page!="home"){
				$("#ugc_linkUpload").hide();
				callback();
			} else {
			
				if(!window.RenderSocial.renderBoxes){
					callback();
				} else {
					var jsLoaded = {};
					var checkLoad = function(name, success){
						jsLoaded[name] = true;
						if(jsLoaded["locali"] && jsLoaded["meteo"]){
							callback();
						}
					}
					RenderSocial.renderBoxes.checkBoxLibrary("locali", checkLoad);
					RenderSocial.renderBoxes.checkBoxLibrary("meteo", checkLoad);
				}
				
			}
		}
	} else {
		if(RenderSocial.disable) RenderSocial.disable("everything");
	}
	return invited;
}

RenderSocial.getCommonFbSettings = function(){
    var fbSettings = {
            appId: RenderSocial.FB_APP_ID
    };
    return fbSettings;
}

RenderSocial.init = function() {
    if($.isFunction($.GeleSocial)) {

        GeleSocial.addStatusChangeCallback(function(last, current){
        	RenderSocial.statusChangeCallback("home", last, current);
        });
        
        var settings = RenderSocial.getCommonSettings();
		settings.socialDataUrl = RenderSocial.SOCIAL_DATA;
		
        var wsSettings = RenderSocial.getCommonWsSettings();
        var fbSettings = RenderSocial.getCommonFbSettings();
        var shadowBoxSettings = RenderSocial.getShadowboxSettings();
        if(RenderSocial.disableBoxes()){
            settings.socialDataUrl = RenderSocial.SOCIAL_DATA + "?noboxes=true";
        }
        $.GeleSocial(settings, wsSettings, fbSettings, shadowBoxSettings);
    }
}

RenderSocial.initProfile = function(withSocialData) {
    if($.isFunction($.GeleSocial)) {
        if(withSocialData===undefined) withSocialData = true;

        GeleSocial.addStatusChangeCallback(function(last, current){
        	RenderSocial.statusChangeCallback("profile", last, current);
        });
        
        var settings = RenderSocial.getCommonSettings();
        if(withSocialData){
            settings.socialDataUrl = RenderSocial.SOCIAL_DATA + "?all=true";
        }
        
        var wsSettings = RenderSocial.getCommonWsSettings();
        var fbSettings = RenderSocial.getCommonFbSettings();
        var shadowBoxSettings = RenderSocial.getShadowboxSettings();

        if(settings.socialDataUrl && RenderSocial.disableBoxes()){
            settings.socialDataUrl = RenderSocial.SOCIAL_DATA + "?noboxes=true";
        }
        $.GeleSocial(settings, wsSettings, fbSettings, shadowBoxSettings);
    }
}

RenderSocial.initLanding = function() {
    if($.isFunction($.GeleSocial)) {

        GeleSocial.addStatusChangeCallback(function(last, current){
        	RenderSocial.statusChangeCallback("landing", last, current);
        });
        
        var settings = RenderSocial.getCommonSettings();		
        var wsSettings = RenderSocial.getCommonWsSettings();
        var fbSettings = RenderSocial.getCommonFbSettings();
        var shadowBoxSettings = RenderSocial.getShadowboxSettings();
        $.GeleSocial(settings, wsSettings, fbSettings, shadowBoxSettings);
    }
}

RenderSocial.initDetail = function() {
    if($.isFunction($.GeleSocial)) {
    
        GeleSocial.addStatusChangeCallback(function(last, current){
        	RenderSocial.statusChangeCallback("detail", last, current);
        }); 
           
        var settings = RenderSocial.getCommonSettings();
        var wsSettings = RenderSocial.getCommonWsSettings();
        var fbSettings = RenderSocial.getCommonFbSettings();
        var shadowBoxSettings = RenderSocial.getShadowboxSettings();
        $.GeleSocial(settings, wsSettings, fbSettings, shadowBoxSettings);
    }
}


RenderSocial.initSection = function() {
    if($.isFunction($.GeleSocial)) {
    
        GeleSocial.addStatusChangeCallback(function(last, current){
        	RenderSocial.statusChangeCallback("section", last, current);
        });     
         
        var settings = RenderSocial.getCommonSettings();
        var wsSettings = RenderSocial.getCommonWsSettings();
        var fbSettings = RenderSocial.getCommonFbSettings();
        var shadowBoxSettings = RenderSocial.getShadowboxSettings();
        $.GeleSocial(settings, wsSettings, fbSettings, shadowBoxSettings);
    }
}

RenderSocial.contaCaratteri = function(id, result) {
    var maxChars = 1000;
    if(window.ugcParams && window.ugcParams.cached && window.ugcParams.cached.lunghezzatesto){
	    var lunghezzaCaratteri = parseInt(window.ugcParams.cached.lunghezzatesto);
	    if(lunghezzaCaratteri) maxChars = lunghezzaCaratteri;
    }
    
    $(id).keyup(function() {
        var len=$(id).val().length;
        var diff = maxChars-len;
        if(diff>=0) {
            $(result).html('Caratteri disponibili: <strong>'+diff+'</strong>');
        } else {
            $(result).html("<font color='#991010'>Attenzione! Hai superato il limite di <strong>"+maxChars+"</strong>&nbsp;&nbsp;caratteri</font>");
        }
        if(len>maxChars) $(id).val(limitField.val().substring(0, limitNum));
    });
}
RenderSocial.addActionFormUgc = function(target){
    var txt = $(target).attr("title");

    $(target).live("focus",function(){
        var len=$(this).val().length;
        if(len!=0 && $(this).val()==txt)
            $(this).val("");
    });

    $(target).live("focusout",function(){
        var len=$(this).val().length;
        if(len==0){
            $(this).val(txt);
        }
    });

    $(target).val(txt);
    
    RenderSocial.setCheckFBUgcForm();
}

RenderSocial.setCheckFBUgcForm = function() {
    $('#'+RenderSocial.UGC_CHECKBOX_COMMENT_ID).change(function(){
        var value = $('#'+RenderSocial.UGC_CHECKBOX_COMMENT_ID).attr("checked");
        GeleSocial.setBoxCookie(RenderSocial.UGC_CHECKBOX_COMMENT_ID, {"values":value});
    });
}

RenderSocial.printCheckFBUgcForm = function() {
    var cb = GeleSocial.getBoxCookie(RenderSocial.UGC_CHECKBOX_COMMENT_ID);
    if(!GeleSocial.utils.isNull(cb) && !GeleSocial.utils.isEmptyString(cb.values)){
        if(cb.values=="true")
            $('#'+RenderSocial.UGC_CHECKBOX_COMMENT_ID).attr("checked", "checked");
        else
            $('#'+RenderSocial.UGC_CHECKBOX_COMMENT_ID).attr("checked", "");
    }
}

RenderSocial.renderUgcForm = function(params) {
    var loc = window.location.href;
    var pos=loc.indexOf(RenderSocial.BASEURL);
    if(!RenderSocial.CHECK_LOCATION || (RenderSocial.CHECK_LOCATION && pos>=0)){
        if(!GeleSocial.utils.isNull(params)) {
            //STAMPO LA FORM
            GeleSocial.ws.ugcForm("#form_ugc", params["idarticolo"], params["brand"],
                    function() {
                        RenderSocial.renderLoggedUgcForm();
                        RenderSocial.addActionFormUgc(RenderSocial.UGC_FORM_COMMENTS_ID);
                        RenderSocial.contaCaratteri(RenderSocial.UGC_FORM_COMMENTS_ID, "#ugc-contatore");
                        

                        //ON SUBMIT --> CHIAMO POST UGC
                        $('#form_ugc').submit(function() {
                            //SE IL VALORE DEL COMMMENTO E' VUOTO
                            if($.trim($(RenderSocial.UGC_FORM_COMMENTS_ID).val())=="" ||
                               $(RenderSocial.UGC_FORM_COMMENTS_ID).attr("title")==$(RenderSocial.UGC_FORM_COMMENTS_ID).val()) {
                                GeleSocial.alert("Inserire un commento");
                                return false;
                            }
                            //APRO MODALE
                            GeleSocial.openSendingComment();
                            GeleSocial.ws.ugcFormPost("#letteraForm", params,
                                function() {
                                    GeleSocial.openCommentSent();
                                    $(':text, textarea').val($(RenderSocial.UGC_FORM_COMMENTS_ID).attr("title"));
                                    $("#ugc-contatore").html('');
                                    //GeleSocial.alert("Commento pubblicato correttamente.");
                                },
                                function(code, msg) {
                                    GeleSocial.closeModal();
                                    if(code) { //TODO: Gestire i codici di commenti
                                        GeleSocial.alert("Errore - Impossibile inviare il commento");
                                        GeleSocial.log("risultato post commento:");
                                        GeleSocial.log("code="+code);
                                        GeleSocial.log("code="+msg);
                                    }
                                }
                            );
                            return false;
                        });
                    },
                    function() {
                        RenderSocial.renderNotLoggedUgcForm();
                    }
            );
        }
    }
}

RenderSocial.renderDetailFormUGC = function() {

    /* UGC */
    if(window.ugcParams && typeof threadProperties != 'undefined' &&
            typeof threadProperties.msgCount != 'undefined' &&
            threadProperties.abilita == 1) {
        if(GeleSocial.utils.isNull(ugcParams["brand"]))
            ugcParams["brand"] = RenderSocial.UGC_BRAND_ID

        if(!GeleSocial.utils.isNull(ugcParams) &&
           !GeleSocial.utils.isNull(ugcParams["idarticolo"]) && !GeleSocial.utils.isNull(ugcParams["brand"]) &&
           !GeleSocial.utils.isNull(ugcParams["title"]) && !GeleSocial.utils.isNull(ugcParams["origin"]) &&
           !GeleSocial.utils.isNull(ugcParams["image"]) && !GeleSocial.utils.isNull(ugcParams["desc"])){
            GeleSocial.log("chiamo la renderUgcForm");
            RenderSocial.renderUgcForm(ugcParams);
        }else{
            $("#"+RenderSocial.UGC_CONTAINER_ID).hide();
            if($("."+RenderSocial.UGC_TOOLS_COMMENTS_CLASS).length!=0) { 
                $("."+RenderSocial.UGC_TOOLS_COMMENTS_CLASS).remove();
            }
        }
    }else{
        $("#"+RenderSocial.UGC_CONTAINER_ID).hide();
        if($("."+RenderSocial.UGC_TOOLS_COMMENTS_CLASS).length!=0) { 
            $("."+RenderSocial.UGC_TOOLS_COMMENTS_CLASS).remove();
        }
    }
}

RenderSocial.detail = function() {
    var parameters = {};

    parameters['site']=RenderSocial.BASEURL;
    parameters['width']='300';
    parameters['height']='300';
    parameters['header']='true';
    var fbHtml = GeleSocial.render.recommendationsString(parameters);

    $("#"+RenderSocial.RECOMMENDATIONS_DETAIL_ID).html(fbHtml);
    $("#"+RenderSocial.RECOMMENDATIONS_DETAIL_ID).after("<br />");

    if(typeof FB != 'undefined')
        FB.init(GeleSocial.fbSettings);

    if($("#"+$.bookmark.BUTTON_CONTAINER_ID).length>0 &&
        typeof $.bookmark != 'undefined')
        $("#"+$.bookmark.BUTTON_CONTAINER_ID).bookmark();
}

RenderSocial.getShadowboxSettings = function(){
    var settings = {
                        width: 700,
                        height: 570
                    };
    return settings;
}

RenderSocial.profileBoxes = function() {
    var pageCookieMap = GeleSocial.getPageCookies();
    $.each(RenderSocial.boxCookieName, function(key, value) {
        var boxName = value;
        var boxLabel = "Valore non selezionato";

        var boxCookie = null;
        if(!GeleSocial.utils.isNull(pageCookieMap)) {
            boxCookie = pageCookieMap[key];
        }
        if(!GeleSocial.utils.isNull(boxCookie) && !GeleSocial.utils.isNull(boxCookie.label)){
            var boxLabel = boxCookie.label;
        }
        $("#custom-user-values").append("<li><strong>"+boxName+":</strong> "+boxLabel+"</li>");
    });
    $("#custom-user-values").show();
}

RenderSocial.renderProfilePlugs = function(){
    var loc = window.location.href;
    var pos=loc.indexOf(RenderSocial.BASEURL);
    if(!RenderSocial.CHECK_LOCATION || (RenderSocial.CHECK_LOCATION && pos>=0)){
        var logged = GeleSocial.isLogged();
        var html = '<ul class="logfb-boxes">\
            <!-- sport-->\
            <ul class="box calcio" id="sport-plug">\
                <li class="title">\
                    <dl class="clearfix">\
                        <dt><a title="" href="http://www.repubblica.it/sport/calcio">Calcio</a></dt>\
                        <dd><a class="edit-box personalizza-box-sport" title="scegli la tua squadra" href="javascript:void(0)">[Scegli squadra]</a></dd>\
                    </dl>\
                </li>\
                <li>\
                    <p class="benefit">\
                        Le notizie sempre aggiornate della tua squadra del cuore\
                        <a rel="shadowbox;height=700;width=900" class="plug_link set_box" href="javascript:void(0)">Scegli il team</a>\
                    </p>\
                </li>\
            </ul>\
            <div id="sport-container" >\
            </div>\
            <!-- edizioni locali-->\
            <ul class="box edizionilocali" id="locali-plug">\
                <li class="title">\
                    <dl class="clearfix">\
                        <dt>Edizioni locali</dt>\
                        <dd><a href="javascript:void(0)" title="scegli l&#039;edizione locale" class="edit-box  personalizza-locali">[Scegli edizione]</a></dd>\
                    </dl>\
                </li>\
                <li>\
                    <p class="benefit">\
                        Seleziona la città per la cronaca locale di tuo interesse\
                        <a rel="shadowbox;height=700;width=900" class="plug_link set_box" href="javascript:void(0)">Edizioni locali</a>\
                    </p>\
                </li>\
            </ul>\
            <div id="locali-container">\
            </div>\
            <!-- meteo-->\
            <ul class="box meteo" id="meteo-plug">\
                <li class="title">\
                    <dl class="clearfix">\
                        <dt><a title="" href="http://meteo.repubblica.it/">Meteo</a></dt>\
                        <dd><a title="Cambia città" href="javascript:void(0);">[Cambia città]</a></dd>\
                    </dl>\
                </li>\
                <li>\
                    <p class="benefit">Inserisci il comune di cui vuoi le previsioni meteo\
                        <a rel="shadowbox;height=700;width=900" class="plug_link set_box" href="javascript:void(0)">Scegli la città</a>\
                    </p>\
                </li>\
            </ul>\
            <div id="meteo-container">\
            </div>\
            <!-- oroscopo-->\
            <ul id="oroscopo-plug" class="box oroscopo">\
                <li class="title">\
                    <dl class="clearfix">\
                        <dt><a title="" href="http://oroscopo.seidimoda.repubblica.it/">Oroscopo</a></dt>\
                        <dd><a title="scegli il tuo segno zodiacale" href="javascript:void(0);">[Scegli segno]</a></dd>\
                    </dl>\
                </li>\
                <li>\
                    <p class="benefit">\
                        Scegli un segno per iniziare ogni giorno con il tuo oroscopo\
                        <a rel="shadowbox;height=700;width=900" class="plug_link set_box" href="javascript:void(0)">Scegli un segno</a>\
                    </p>\
                </li>\
            </ul>\
            <div id="oroscopo-container">\
            </div>\
        </ul>';
        html = $(html);
        html.find("#locali-plug li.title dd").hide();
        //html.find("#borsa-plug li.title dd").hide();
        html.find("#sport-plug li.title dd").hide();
        html.find("#meteo-plug li.title dd").hide();
        html.find("#oroscopo-plug li.title dd").hide();
        $(RenderSocial.SOCIAL_DIV).append(html);
        $("a.plug_link").live("click", function(){GeleSocial.openLoginModal()});
    }
}

RenderSocial.enableProfilePlugs = function(){
    $("a.plug_link").die();
    var html = $(RenderSocial.SOCIAL_DIV);

    html.find("#locali-plug li.title dd, #locali-plug p.benefit a.plug_link").click(function(){
        RenderSocial.renderBoxes.showBoxPreferenceSelection("locali", html.find("#locali-container"),  html.find("#locali-plug"));
    });
    html.find("#locali-plug p.benefit a.plug_link").html("Scegli edizione");

    html.find("#sport-plug li.title dd, #sport-plug p.benefit a.plug_link").click(function(){
        RenderSocial.renderBoxes.showBoxPreferenceSelection("sport", html.find("#sport-container"),  html.find("#sport-plug"));
    });
    html.find("#sport-plug p.benefit a.plug_link").html("Scegli squadra");

    html.find("#meteo-plug li.title dd, #meteo-plug p.benefit a.plug_link").click(function(){
        RenderSocial.renderBoxes.showBoxPreferenceSelection("meteo", html.find("#meteo-container"),  html.find("#meteo-plug"));
    });
    html.find("#meteo-plug p.benefit a.plug_link").html("Cambia città");

    html.find("#oroscopo-plug li.title dd, #oroscopo-plug p.benefit a.plug_link").click(function(){
        RenderSocial.renderBoxes.showBoxPreferenceSelection("oroscopo", html.find("#oroscopo-container"),  html.find("#oroscopo-plug"));
    });
    html.find("#oroscopo-plug p.benefit a.plug_link").html("Scegli segno");

    html.find("#locali-plug li.title dd").show();
    //html.find("#borsa-plug li.title dd").show();
    html.find("#sport-plug li.title dd").show();
    html.find("#meteo-plug li.title dd").show();
    html.find("#oroscopo-plug li.title dd").show();
    //$("p.benefit a.set_box").hide();

    //tooltip-guiders
    RenderSocial.tooltip.calcio();
    RenderSocial.tooltip.oroscopo();
    RenderSocial.tooltip.edizioniLocali();
    RenderSocial.tooltip.meteo();
}

RenderSocial.renderLoggedUgcForm = function() {
    var loc = window.location.href;
    var pos=loc.indexOf(RenderSocial.BASEURL);
    if(!RenderSocial.CHECK_LOCATION || (RenderSocial.CHECK_LOCATION && pos>=0)){
        
        var name = GeleSocial.status.user['nickname'];
        if(GeleSocial.status.user["facebookid"]){        
       		name = GeleSocial.status.user['firstname'] + " " + GeleSocial.status.user['lastname']
        }
        	
        var img = RenderSocial.BASEURL_SOCIAL+"img/nobody.gif";
        var avatarHtml = '';
        if(GeleSocial.isLoggedFb()){
            img = "https://graph.facebook.com/" + GeleSocial.status.user[GeleSocial.fbId] + "/picture";
            avatarHtml = '<div id="fbavatar"></div>';
        }

        var html = '<div class="clear"></div>';
        html += '<dt>'+name+'</dt>';
        html += '<dd class="avatar"><img src=\"'+img+'\" alt=\"\" height=\"50\" width=\"50\" \/>';
        html += avatarHtml;
        html += '</dd>';

        $(RenderSocial.SOCIAL_DIV).append(html);
        $("#"+RenderSocial.SOCIAL_BOTTOM).css("display","block");
        RenderSocial.printCheckFBUgcForm();
     }
}

RenderSocial.renderNotLoggedUgcForm = function() {
    var loc = window.location.href;
    var pos=loc.indexOf(RenderSocial.BASEURL);
    if(!RenderSocial.CHECK_LOCATION || (RenderSocial.CHECK_LOCATION && pos>=0)){
        var html = '<!-- start social comment notlogged --><p class="ugclink"><a rel="shadowbox;height=550;width=700" href="javascript:void(0)"><strong>Scrivi un commento</strong></a></p><!-- end social comment notlogged -->';

		var element = $("#ugc_count").first();
		if(element.length==0){
			element = $('#'+RenderSocial.UGC_CONTAINER_ID).first();
		}
        element.before(html);
        $(".ugclink").live("click", function(){GeleSocial.openLoginModal();});
     }
}

RenderSocial.renderUserProfile = function(user) {
    var loc = window.location.href;
    var pos=loc.indexOf(RenderSocial.BASEURL);
    if(!RenderSocial.CHECK_LOCATION || (RenderSocial.CHECK_LOCATION && pos>=0)){
           var uName = "";
           if(GeleSocial.utils.isEmptyString(user['firstname']))
                uName = user['nickname'];
           else
                uName = user['firstname'];

           var html = '<dl class="avatar clearfix"><dt><img src=\"img/nobody.gif\" alt=\"\" height=\"50\" width=\"50\" \/></dt>';
           html += '<dd class="user">Ciao ' + uName + '!</dd>';

           html += '<dd class="links">\
        <div class="clear"></div>\
        <a href="javascript:GeleSocial.goToMemberCenter()">Dati personali</a> | <a href="setpassword.php">Modifica la password</a> | <a href="javascript:GeleSocial.logOut()"><strong>Esci</strong></a></dd>';

           $(RenderSocial.SOCIAL_DIV).prepend(html);
           //RenderSocial.hideLoading();
           $("ul.logged-ugc").css("display","block");
           $(RenderSocial.PP_LOGIN_2_APPROVE_DIV).css("display","block");
     }
}


RenderSocial.disable = function(name){

	$("dl.social").hide();
	RenderSocial.insertGoogleAnalytics();
	
}

RenderSocial.renderFBUserProfile = function(user) {
    GeleSocial.log("renderFBUserProfile");
    var loc = window.location.href;
    var pos=loc.indexOf(RenderSocial.BASEURL);
    if(!RenderSocial.CHECK_LOCATION || (RenderSocial.CHECK_LOCATION && pos>=0)){
      var uName = "";
      if(GeleSocial.utils.isEmptyString(user['firstname']))
          uName = user['nickname'];
      else
          uName = user['firstname'];

      var html = '<dl class="avatar clearfix"><dt><img height="50" width="50" alt="" src=\"https://graph.facebook.com/' + user[GeleSocial.fbId] + '/picture\" \/><div id="fbavatar"></div></dt>';
      html += '<dd class="user">Ciao ' + uName + '!</dd>';

      html += '<dd class="links">\
        <div class="clear"></div>\
        <a href="javascript:GeleSocial.goToMemberCenter()">Dati personali</a> | <a href="setpassword.php">Modifica la password</a> | <a href="javascript:GeleSocial.logOut()"><strong>Esci</strong></a></dd>';
      //html += '<ul class=\"box logfb-sx\" id=\"custom-user-values\">\n<li class=\"title\">\n<dl class=\"clearfix\"><dt>Homepage personalizzata</dt></dl>\n</li>\n</ul>';

      $(RenderSocial.SOCIAL_DIV).prepend(html);
      //RenderSocial.hideLoading();
      $("ul.logged-facebook").css("display","block");
   }
}

RenderSocial.pages = {
	
	notlogged: function(){
		if(RenderSocial.statusBar) RenderSocial.statusBar.renderNotLogged(false);
	},
	
	home: {
		
		finalStatus: function(){

			RenderSocial.pages.home.temperature();
		
		},
	
		loaded: function(){

			if(RenderSocial.disableBoxes()){
		       	RenderSocial.disable("boxes");
        	}

			$("a.plug_link").live("click", function(){GeleSocial.openLoginModal()});
			var txt  = '<a href="javascript:void(0);" class="login-modal t-right" ><strong>Connettiti a La tua Repubblica.it</strong></a> e personalizza la tua homepage.';
			RenderSocial.renderLoginString($("#fb-status-user"), txt);

			/*
			var parameters = {};
			parameters['href']=RenderSocial.FB_APP_URL;
			parameters['width']='222';
			parameters['height']='198';
			parameters['header']='false';
			parameters['stream']='false';
			parameters['show_faces']='true';
			parameters['colorscheme']='light';
			parameters['background-color']='#ffffff';
			parameters['border-color']='#ffffff';
			
			var html = GeleSocial.render.likeBoxString(parameters);
			$("#fb-home-like-box").html(html);
			if(typeof FB != 'undefined'){
				FB.init(GeleSocial.fbSettings);
				//$("#fb-home-like-box").css("background-color","#fff");
				//$("#fb-home-like-box").css("margin-bottom","5px");
			}
			*/
			html = '<a rel="shadowbox;height=700;width=900" href="javascript:void(0);"><strong>Per saperne di più...</strong></a>';
			$(".home-boxes-benefits").html(html).live("click", function(){GeleSocial.showBenefits();});
			
		},

		logged: function(){
		
			$("a.plug_link").click(function(){
				var guider = $(this).attr("title");
				location.href = RenderSocial.FRIENDS_ACTIVITY+"#guider="+guider;
				return false;
			});

			if(!RenderSocial.disableBoxes()){

				RenderSocial.renderBoxes.renderSport({"edit": false});
				RenderSocial.renderBoxes.renderOroscopo({"edit": false});
				RenderSocial.renderBoxes.renderMeteo({"edit": false});
				RenderSocial.renderBoxes.renderLocali({"edit": false});
				RenderSocial.renderBoxes.renderBorsa({"edit": false});

				$(".social").addClass("logged");
				var html = '<p><a href="'+RenderSocial.FRIENDS_ACTIVITY+'" id="login-modal"><strong class="highlight">Accedi</strong> alla tua pagina personale</a></p>';
				$("#fb-connect").html(html);
			}			
	
		},

		temperature: function(){
			if(GeleSocial.status.fb.blocked) return;

			if(typeof $.facebookGELE!='undefined' && window.jsonFacebook){
				$(".col-C .sottospalla .articles").facebookGELE({variable: jsonFacebook});
				GeleSocial.log("print facebook switch");
				$.facebookGELE.printFacebookSwitch($(".col-C .sottospalla").slice(0,1));
				$.facebookGELE.checkEnabled();
			}

		},
		
		notlogged: function(){
			RenderSocial.pages.home.loginFBOnly();
		},
		
		loginFBOnly: function(){
			
			var htmlAccediSpalla = '<div class="box-articles social clearfix">\
										<a id="gs-sottospalla-fb-login" href="javascript:void(0)"><img border="0" alt="Accedi" src="' + RenderSocial.BASEURL_SOCIAL + 'img/login-button.png"></a>\
									    <h2><a id="gs-sottospalla-fb-claim" href="javascript:void(0)">Accedi e personalizza</a></h2>\
									    <h2 class="rblu"><a href="https://apps.facebook.com/gsrepubblica/" onclick="window.open(this.href);return false;">Scopri Repubblica Blu su Facebook</a></h2>\
									</div>';
			
			htmlAccediSpalla = $(htmlAccediSpalla);
			$("div.sottospalla").first().before(htmlAccediSpalla);

			$("#gs-sottospalla-fb-login,#gs-sottospalla-fb-claim").live("click", function(){
				if(GeleSocial.status.fb.blocked){
					GeleSocial.openLoginModal();
				} else {
					GeleSocial.openLoginModal(undefined,undefined,undefined,undefined,true);
				}
				return false;
			});	
				
		}	

	},
 
	detail: {

		loaded: function(){

			if($('#fb-like-head').length != 0) 
				$('#fb-like-head').html('<fb:like name="platform" layout="button_count" show_faces="true" width="200" action="recommend" colorscheme="light" height="21" id=""></fb:like>');
			if($('#fb-like-foot').length != 0)
				$('#fb-like-foot').html('<fb:like name="platform" layout="standard" show_faces="false" width="450" action="recommend" font="arial" colorscheme="light" height="35" ></fb:like>');
			if($('#fb-like-head-dirette').length != 0)
				$('#fb-like-head-dirette').html('<fb:like name="platform" layout="standard" show_faces="false" width="300" action="recommend" font="arial" colorscheme="light" height="50" ></fb:like>');

			RenderSocial.renderDetailFormUGC();		
		},
		
		logged: function(){
			RenderSocial.detail();
		},
		
		notlogged: function(){
			var fbHtml = '<div class="adv"><a href="' + RenderSocial.BASEURL_SOCIAL + 'invitation_landing.php"><img src="' + RenderSocial.BASEURL_SOCIAL + 'img/fb-consigli-fake.gif" alt="Scopri quali articoli interessano ai tuoi amici di Facebook" /></a></div>';
			$("#"+RenderSocial.RECOMMENDATIONS_DETAIL_ID).html(fbHtml);
			$.bookmark.setLabelAdd(function(){
				GeleSocial.openLoginModal();
			});
		}
		
	},

	profile: {
	
		logged: function(){

			// sondaggio, da buttare in seguito	
		    $(RenderSocial.SOCIAL_DIV).append('<ul class="box promo">\
				<li>Problemi tecnici? <a href="https://help.kataweb.it/assistenza/social/repubblica/richiesta.php" onclick="window.open(this.href);return false" >Contattaci</a></li>\
				</ul>');
		    
		    if(GeleSocial.isLoggedFb()){
     			RenderSocial.renderFBUserProfile(GeleSocial.status.user);
     		} else {
     			RenderSocial.renderUserProfile(GeleSocial.status.user);
     		}
     		
     		displayLoggedBoxProfile();			

		},

		notlogged: function(){
			displayNotLoggedBoxProfile();
		}
	
	}

}

RenderSocial.insertGoogleAnalytics = function(){
	try {
		
		if(window._gaq) return;
		window._gaq = [];
		window._gaq.push(['_setAccount', 'UA-7751748-18']);
		window._gaq.push(['_deleteCustomVar', 1]);
		window._gaq.push(['_deleteCustomVar', 2]);
		
		if(GeleSocial.status && GeleSocial.status.logged)
			window._gaq.push(['_setCustomVar', 1, 'social_result', 'loggato', 3]);
		else
			window._gaq.push(['_setCustomVar', 1, 'social_result', 'non_loggato', 3]);	
		
		window._gaq.push(['_trackPageview']);
		
		(function() {
		var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
		ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
		var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
		})();
		
	} catch(e){
		GeleSocial.log("ERRORE: " + e);
	}
}

RenderSocial.statusChangeCallback = function(page, last, current){
	
	var ishome = page == "home";
	var isdetail = page=="detail";
	var isprofile = page=="profile";

	// nel momento in cui si conosce lo stato iniziale
	if(!last.loaded && current.loaded){

		if(ishome){

			RenderSocial.pages.home.loaded();

 		} else if(isdetail){

			RenderSocial.pages.detail.loaded();

		}

    }
	
	// quando lo stato passa da temporaneo a definitivo
	if(last.transitional && !current.transitional){

		RenderSocial.insertGoogleAnalytics();

		if(ishome){
			
			RenderSocial.pages.home.finalStatus();

		}	
		
		if(current.logged){
			 
			 if(RenderSocial.statusBar) RenderSocial.statusBar.renderLogged();
	  	 	 if(isdetail){
	  	 	 
					RenderSocial.pages.detail.logged();

	   		 } else if(isprofile){

				RenderSocial.pages.profile.logged();

	   		 } else if(ishome){

				RenderSocial.pages.home.logged();

	   		 }

		} else {
			
			RenderSocial.pages.notlogged();
			
			if(isprofile){
			
				RenderSocial.pages.profile.notlogged();
			
			} else if(isdetail){
			
				RenderSocial.pages.detail.notlogged();
			
			} else if(ishome){
			
				RenderSocial.pages.home.notlogged();
			
			}

		}
    }
}

RenderSocial.renderLoginString = function(node,text){
    node.html(text);
    node.find("a.login-modal").live("click", function(){
            if(RenderSocial.statusBar) RenderSocial.statusBar.hideAllPopups();
            GeleSocial.openLoginModal();
        });
    node.find("a.login-benefits").live("click", function(){
            if(RenderSocial.statusBar) RenderSocial.statusBar.hideAllPopups();
            GeleSocial.showBenefits();
        });

}

RenderSocial.breadCrumbs = function(element,text){
    var html ="<li>Sei in:&nbsp;</li>"+
        "<li><a href=\""+RenderSocial.FRIENDS_ACTIVITY+"\" title=\"Torna alla Home\">Pagina di profilo</a> /</li>"+
        "<li> "+text+" </li>";
        "<div class='clear'></div>";
    if(!GeleSocial.utils.isNull(element))
        $(element).html(html);
    else{
        html = "<ul class='breadcrumb'>"+html+"</ul>";
        $("#"+RenderSocial.CUSTOM_CENTER_DIV_ID).prepend(html);
    }
}

/*---------------------- Class Share
    -------------------------------------------*/
    RenderSocial.share = {};

    RenderSocial.share.getGooglePlus = function(url, title) {
        return '<div class="g-plusone" data-size="medium" data-href="' + url + '"></div>';
    }

    RenderSocial.share.getTwitterFollow = function(url, title) {
        return "<a href=\"http://twitter.com/share\" class=\"twitter-share-button\" data-via=\"repubblicait\" data-url=\""+url+"\" data-text=\""+title+"\" data-count=\"true\">Tweet</a>";
    }

    RenderSocial.share.renderFacebookPlugs = function() {
        if(typeof FB != 'undefined')
            FB.init(GeleSocial.fbSettings);
    }

    RenderSocial.share.renderGooglePlugs = function(id) {
        var success = function(){
	        if(id) gapi.plusone.go(id);
	        else gapi.plusone.go();
        }
        if(window.gapi) success();       
        else {

            window.___gcfg = {
                lang: 'it-IT',
                parsetags: 'explicit'
            };

	        $.ajax({
	            url: "https://apis.google.com/js/plusone.js",
	            dataType: 'script',
	            cache: true,
	            success: success
	        });
        }
    }

    RenderSocial.share.renderTwitterPlugs = function() {
        $.ajax({
            url: "http://platform.twitter.com/widgets.js",
            dataType: 'script',
            cache: true
        });
    }

    /*---------------------- Class Share
    -------------------------------------------*/
    RenderSocial.tooltip = {};

    RenderSocial.tooltip.edizioniLocali = function(){
        if(typeof guiders != 'undefined'){
            guiders.createGuider({
                attachTo: ".edizionilocali",
                buttons: [{name:"Chiudi finestra", onclick: guiders.hideAll}],
                description: "",
                id: "locali",
                position: 3,
                title: "Scegli la città di tuo interesse",
                width: 400
            });
        }
    }

    RenderSocial.tooltip.calcio = function(){
        if(typeof guiders != 'undefined'){
            guiders.createGuider({
                attachTo: ".calcio",
                buttons: [{name:"Chiudi finestra", onclick: guiders.hideAll}],
                description: "",
                id: "calcio",
                position: 3,
                title: "Scegli la tua squadra preferita",
                width: 400
            });
        }
    }

    RenderSocial.tooltip.meteo = function(){
        if(typeof guiders != 'undefined'){
            guiders.createGuider({
                attachTo: ".meteo",
                buttons: [{name:"Chiudi finestra", onclick: guiders.hideAll}],
                description: "",
                id: "meteo",
                position: 3,
                title: "Scegli la località di tuo interesse",
                width: 400
            });
        }
    }

    RenderSocial.tooltip.oroscopo = function(){
        if(typeof guiders != 'undefined'){
            guiders.createGuider({
                attachTo: ".oroscopo",
                buttons: [{name:"Chiudi finestra", onclick: guiders.hideAll}],
                description: "",
                id: "oroscopo",
                position: 3,
                title: "Scegli il segno zodiacale",
                width: 400
            });
        }
    }
